// ==UserScript==
// @name Google-Translate
// @author Lex1
// @version 1.6.18
// @description  Google-Translate. Use button with similar code "javascript:ujs_google_translate('auto|ru')".
// @ujs:documentation http://lexi.ucoz.ru/index/0-5
// @ujs:download http://lexi.ucoz.ru/google-translate.js
// ==/UserScript==



opera.addEventListener('BeforeExternalScript', function(e){
	var s = e.element.src; var h = location.href;
	if(s == 'http://translate.google.com/translate_t.js' && h.indexOf('&ujs=gtt') == h.length-8){
		e.preventDefault();
		opera.addEventListener('BeforeScript', function(ev){ev.preventDefault()}, false);
		opera.addEventListener('BeforeEventListener.load', function(ev){if(ev.listener.toString().indexOf('.focus()') != -1)ev.preventDefault()}, false);
	}
}, false);

document.addEventListener('mouseup', function (e){if(e && e.button == 0){opera.lastClickX = e.clientX; opera.lastClickY = e.clientY}}, false);

function ujs_createWindow(txt, status){
	var txtLen = txt.length; var tbId = 'ujs_toolbar'; if(arguments.length > 3)tbId += arguments[3];
	var toolbar = document.getElementById(tbId); if(toolbar)toolbar.parentNode.removeChild(toolbar); toolbar = document.createElement('div'); toolbar.id = tbId;
	var h = 15; var w = 20; if(txtLen > 2000 || window.innerHeight < 200 || window.innerWidth < 300){h = 50; w = 66}else if(txtLen > 250){h = 25; w = 33}; h = parseInt(h*window.innerHeight/100); w = parseInt(w*window.innerWidth/100);
	var title = (arguments.length > 2) ? arguments[2] : '<a href="http://translate.google.com/" target="_blank" style="text-decoration:none;color:#000099;font:16px Times New Roman;">Google Translate</a>';
	var img = '<img src="data:image/gif;base64,R0lGODlhAQABAIABAAAAAP///yH5BAEAAAEALAAAAAABAAEAAAICTAEAOw==" title="Close" width="18" height="18" onclick="this.parentNode.parentNode.removeChild(this.parentNode)" style="float:right;background:-o-skin(\'Caption Close Button Skin\');padding:0;margin:0;border:none;cursor:pointer;">';
	toolbar.innerHTML = img+'&nbsp;'+title+'<div style="display:block;border:1px solid #aaaaaa;margin:2px 0 0 0;padding:4px;background-color:#fafcfe;font:14px Times New Roman;height:'+h+'px;width:auto;overflow:auto;cursor:text;">'+txt+'</div><div style="display:block;font:10px Times New Roman;color:#555555;padding:0;margin:1px 2px;cursor:text;">'+status+'</div>';
	toolbar.setAttribute('style', 'position:fixed;display:block;visibility:hidden;left:0;top:0;height:auto;width:'+w+'px;background:-o-skin(\'Window Skin\');font:16px Times New Roman;border:1px solid gray;padding:3px;z-index:9997;overflow:visible;cursor:move;');
	toolbar.addEventListener('mousedown', function(e){
		if (e.target == toolbar){
			e.preventDefault(); toolbar.style.zIndex = 9998;
			var grabX = e.clientX; var grabY = e.clientY;
			var origX = parseInt(toolbar.style.left); var origY = parseInt(toolbar.style.top);
			var dnd = function(e){
				toolbar.style.left = origX+e.clientX-grabX+'px';
				toolbar.style.top = origY+e.clientY-grabY+'px';
				if(opera && opera.version() >= 9 && opera.version() < 9.5){
					if(toolbar.style.zIndex <= 9999){toolbar.style.zIndex++}else{toolbar.style.zIndex--};
				};
			};
			document.addEventListener('mousemove', dnd, false);
			document.addEventListener('mouseup', function(e){document.removeEventListener('mousemove', dnd, false); toolbar.style.zIndex = 9997}, false);
		}
	}, false);
	document.documentElement.appendChild(toolbar);
	var halfWidth = parseInt(toolbar.offsetWidth/2);
	var strict = document.compatMode == 'CSS1Compat' && opera && opera.version() >= 9.5;
	var mX = (strict ? document.documentElement.clientWidth : document.body.clientWidth)-toolbar.offsetWidth;
	var mY = (strict ? document.documentElement.clientHeight : document.body.clientHeight)-toolbar.offsetHeight;
	toolbar.style.left = (opera && opera.lastClickX < mX+halfWidth) ? (opera.lastClickX > halfWidth ? (opera.lastClickX-halfWidth) : 0) : mX;
	toolbar.style.top = (opera && opera.lastClickY < mY) ? opera.lastClickY : mY;
	toolbar.style.visibility = 'visible'; return toolbar;
};

document.addEventListener('message', function(ev){
	if(ev.data == 'googletranslate' || ev.data == 'translateru'){
		parent = ev.source;
		var result = ''; var status = '';
		if(ev.data == 'googletranslate'){
			var r = document.getElementById('result_box'); var a = document.getElementById('autotrans');
			if(r)result = r.innerHTML; if(a)status = a.innerText.replace(/^.*: /, '').toLowerCase();
		}
		if(ev.data == 'translateru'){
			var p = document.getElementsByTagName('p');
			for(var i=0, pi; pi=p[i]; i++){
				if(pi.className == 'dir')status = pi.lastChild.nodeValue+' (PROMT)'; if(pi.className == 'result')result = pi.innerHTML;
			}
		}
		ev.source.postMessage('google_translate'+status+'googletranslatestatus'+result);
	}
	if(ev.data.indexOf('google_translate') == 0){
		parent = parent.parent;
		var rez = ev.data.substr(16).split('googletranslatestatus');
		ujs_createWindow(rez[1], rez[0]);
		var gt = document.getElementById('ujs_googletranslateframe');
		if(gt)gt.parentNode.removeChild(gt);
	}
}, false);

function ujs_google_translate(dir){
	var getSelText = function(w){return w.document.body instanceof HTMLFrameSetElement ? '' : w.document.selection.createRange().text};
	var findSelWin = function(w){var rez; try{if(getSelText(w)){rez = w}else{for(var i = 0, f; f = w.frames[i]; i++){if(rez = findSelWin(f))break}}}catch(e){}; return rez};
	var createFrame = function(w, src, post, lng){
		with(w){
			ujs_createWindow('', (lng == 'ru' ? '\u041F\u0435\u0440\u0435\u0432\u043E\u0434\u0438\u043C' : 'Translating')+'\u2026');
			var gtfId = 'ujs_googletranslateframe'; var f = document.getElementById(gtfId); if(!f)f = document.createElement('iframe');
			f.width = 0; f.height = 0; f.frameBorder = 'no'; f.scrolling = 'no'; f.id = gtfId; f.src = src;
			f.onload = function(){if(window.postMessage){f.contentWindow.postMessage(post)}else{f.contentDocument.postMessage(post)}};
			document.documentElement.appendChild(f);
		}
	};
	var w = findSelWin(window.top); var lng = (navigator.language == 'ru') ? 'ru' : 'en';
	if(dir.indexOf('|') != -1){
		if(w && w.location.hostname != 'translate.google.com')
			createFrame(w, 'http://translate.google.com/translate_t?text='+encodeURIComponent(getSelText(w))+'&hl='+lng+'&langpair='+dir+'&tbb=1&ujs=gtt', 'googletranslate', lng);
		else
			window.open('http://translate.google.com/translate?u='+escape(location.href)+'&hl='+lng+'&langpair='+dir+'&tbb=1'+(document.charset ? '&ie='+document.charset : ''));
	}
	else{
		if(w && w.location.hostname != 'wap.translate.ru')
			createFrame(w, 'http://wap.translate.ru/wap2/translator.aspx/result/?tbDirection='+dir+'&tbText='+encodeURIComponent(getSelText(w))+'&Submit=', 'translateru', lng);
		else
			window.open('http://www.translate.ru/url/tran_url.asp?direction='+dir+'&template=General&autotranslate=true&url='+escape(location.href));
	}
};
