' Spell-Checker for clipboard contents.  Requires MS Word.
' Steve Yandl, October 23, 2000. Lex1, February 12, 2007.
' /////////////////////////////////////////////////////////////////

Dim WshShell, oWD, RangeOriginal, RangeCorrected, Text
Set WshShell = WScript.CreateObject("WScript.Shell")
Set oWD = WScript.CreateObject("Word.Application")
oWD.Visible = False
oWD.Documents.Add
On Error Resume Next
oWD.Selection.Paste
If Err.Number <> 0 Then
	Close
	Text = WshShell.Popup("  !", 3)
	WScript.Quit
End If

Set RangeOriginal = oWD.ActiveDocument.Range(0, oWD.Selection.End)
Text = RangeOriginal.Text

If Not oWD.CheckSpelling(RangeOriginal) Or Not oWD.CheckGrammar(RangeOriginal) Then
	If Err.Number = 0  Then
		oWD.ActiveDocument.CheckGrammar
	Else
		oWD.ActiveDocument.CheckSpelling
	End If
End If

If RangeOriginal <> Text Then
	Set RangeCorrected = oWD.ActiveDocument.Range(0, oWD.Selection.End)
	RangeCorrected.Copy
	oWD.Visible = False
	Close
	WshShell.SendKeys "+{INSERT}"
Else
	Close
	Text = WshShell.Popup("   .", 3)
End If
WScript.Quit

Sub Close()
	oWD.ActiveDocument.Close wdDoNotSaveChanges
	oWD.Quit
	Set oWD = Nothing
End Sub
